// NoPro - webwork 2013

/* auto-complete textbox */

var nopro_auto_arr = [];

function gotkey(eve) {
    if(eve.ctrlKey) return true;
    //dbg(''); dump_obj(eve, true);
    //dbg(''); dump_obj(eve.originalEvent, true);
    //dbg("key: "+eve.key, true, 'msg');

    //if(eve.keyCode == 0)
    dump_obj(eve, true);
    dbg("keyCode: "+eve.keyCode, true, 'msg'); //return true;
    
    var tbox = eve.delegateTarget;
    //dbg(''); dump_obj(tbox, true);
    var name = tbox.name;
    var text = tbox.value;
    var sbox = document.getElementsByName('sel_' + name)[0];
    /**/
    if(text.length < 2) {
	$(sbox).hide();
	return true;
    } else {
	$(sbox).show();
    }
    /**/
    
    // switch(eve.key) is not compatible with chrome
    switch(eve.keyCode) {

      case 27: // ESC-Key
	if(tbox.nopro)
	    tbox.value = tbox.nopro;
	$(sbox).children()
	    .removeClass('sel')
	    .removeAttr('selected')
	;
	// fall through
      case 13: // Return
	tbox.nopro = null;
	$(sbox).hide();
	//return false; // break event-handler-chain
	break;

      case 33: // PgUp-Key
      case 34: // PgDn-Key
      case 37: // Left-Key
      case 39: // Right-Key
	break;

      case 38: // Up-Key
      case 40: // Down-Key

	var its = $(sbox).children();
	if(its.length < 1) break;
	
	var itid = -1;
	for(var i=0; i < its.length; i++) {
	    if($(its[i]).attr('selected') == 'selected') {
		itid = i;
		break;
	    }
	}
	if(itid < 0)
	    itid = 0;
	else
	    itid += eve.keyCode - 39;
	if(itid < 0)
	    itid += its.length;
	else if(itid >= its.length)
	    itid -= its.length;
	dbg('name: '+name+', itid: '+itid+'/'+its.length, true, 'msg');
	var item = its[itid];
	//dump_obj($(item).offset(), true);
	
	var y0 = $(sbox).prop('scrollTop');
	var y1 = $(item).offset().top;
	var y2 = sbox.clientHeight;	// sbox.offsetHeight;
	if(y1 < 40)
	    $(sbox).animate({'scrollTop': y0-40 + y1}, 125);
	else if(y2-y1 < 0)
	    $(sbox).animate({'scrollTop': y0-y2 + y1}, 125);

	$(sbox).children()
	    .removeClass('sel')
	    .removeAttr('selected')
	;
	$(item)
	    .addClass('sel')
	    .attr('selected', 'selected')
	;
	if(!tbox.nopro) {
	    // store input
	    tbox.nopro = tbox.value;
	    //dbg('tbox.nopro set: '+tbox.nopro, true, 'dat');
	}
	tbox.value = item.textContent;
	return false; // break event-handler-chain
	break;

      default:
	if(text.length < 2) {
	    $(sbox).hide();
	    return true;
	} else {
	    if(eve.keyCode < 38 && eve.keyCode != 8 && eve.keyCode != 0) return true;
	    if(eve.ctrlKey) return true;
	    
	    var regex = new RegExp('(^| )' + text, "i");
	    tbox.nopro = null;
	    
	    //var sbox = document.getElementsByName('sel_' + name)[0];
	    sbox.innerHTML = '';
	    for(var i=0; i < nopro_auto_arr[name].length; i++) {
		var tmp = nopro_auto_arr[name][i];
		if(regex.test(tmp)) {
		    opt = document.createElement('li');
		    opt.textContent = tmp;
		    sbox.appendChild(opt);
		}
	    }
	}
    }
    
    return true; // continue event-handler-chain
}

function subs(eve) {
    // li:hover - event-handler
    var sbox = eve.delegateTarget;
    var item = eve.target;
    var name = sbox.name.substr(4);
    var text = item.textContent;
    var tbox = document.getElementsByName(name)[0];
    if(!tbox.nopro) {
	// store input
	tbox.nopro = tbox.value;
	//dbg('tbox.nopro set: '+tbox.nopro, true, 'dat');
    }
    tbox.value = text;
    $(sbox).children()
	.removeClass('sel')
	.removeAttr('selected')
    ;
    $(item)
	.addClass('sel')
	.attr('selected', 'selected')
    ;
    return true;
}

function choose(eve) {
    // li:click - event-handler
    var sbox = eve.delegateTarget;
    var item = eve.target;
    var name = sbox.name.substr(4);
    var text = item.textContent;
    var tbox = document.getElementsByName(name)[0];
    dbg('click() @ ' + sbox.name, true, 'msg');
    dbg('sel: ' + sbox.tagName, true, 'dat');
    tbox.nopro = null;
    $(sbox).hide();
    return true;
}

function nopro_auto_init(jqq, arr) {
    var name = $(jqq)[0].name;
    nopro_auto_arr[name] = arr;
    $(jqq).after('<ul name ="'+ 'sel_'+name +'"class="nopro_auto_sel"></ul>');
    var jqqsel = 'ul[name="'+ 'sel_'+name +'"]';
    var sbox = $(jqqsel)[0];
    sbox.name = 'sel_'+name;
    $(sbox).hide();
    $(jqq).keyup(function(e) { return gotkey(e) });
    $(sbox)
	.delegate('li', 'hover', function(e) { return subs(e) })
	.delegate('li', 'click', function(e) { return choose(e) })
    ;
}
