// NoPro - webwork 2012

/*
 * some handy jquery-functions
 */

/* 2013-02-05: bugfix: fixed in nopro_jq.js
 * kept this as "nopro_jg1.js" for compatibility with already implemented workarounds
 * it contains bugy use of width() instead of outerWidth(true)
 */

// global vars
CRLF = "\r\n";

/* for all jqc-functions jqobjects must have absolute positions */

/* jqo and jq2 have same parentNode or jq2 is $(window) */
function nopro_jqchoff(jqo, jq2) { return ((jq2.offset()) ? jq2.offset().left : 0) + parseInt((jq2.width() - jqo.outerWidth()) / 2); }
function nopro_jqcvoff(jqo, jq2) { return ((jq2.offset()) ? jq2.offset().top : 0) + parseInt((jq2.height() - jqo.outerHeight()) / 2); }
function nopro_jqch(jqo, jq2) { jqo.css('left', nopro_jqchoff(jqo, jq2) +'px'); }
function nopro_jqcv(jqo, jq2) { jqo.css('top', nopro_jqcvoff(jqo, jq2) +'px'); }

/* center jqo inside parent */
function nopro_jqc2phoff(jqo) { return parseInt((jqo.parent().width() - jqo.width()) / 2); }
function nopro_jqc2pvoff(jqo) { return parseInt((jqo.parent().height() - jqo.height()) / 2); }
function nopro_jqc2ph(jqo) { jqo.css('left', nopro_jqc2phoff(jqo) +'px'); }
function nopro_jqc2pv(jqo) { jqo.css('top', nopro_jqc2pvoff(jqo) +'px'); }

////////////////

function get_urlreq(url) {
    var robj = {};
    var req = url.split('?');
    if(req.length > 1) { $.each(req[1].split('&'), function(k, v) { q=v.split('='); robj[q[0]]=q[1]; }); }
    return robj;
}

function get_cookies(cs) {
    var robj = {};
    $.each(cs.split(';'), function(k, v) { q=v.split('='); robj[q[0].trim()]=q[1]; });
    return robj;
}

/* -.-.- */
