<?php
# some storage classes

require_once('nopro_lib.php');

class np_http_hdr {

  protected
    $raw,
    $data,
    $stats = array(),
    $EOprots;
  
  public function __construct($raw) {
    $this->$data = $this->parse($this->raw = $raw); // parse() is called as a static method
  }

  public function __toString() { return $this->data; }

  protected function parse($raw) {
    // based on npwg_parse_hdr() in nopro_wget.php
    if(!$hdr) return (object)array('stat' => 0);
    $head = new stdclass;
    foreach(explode(CRLF, $hdr) as $line) {
      if(!$line) continue;
      if(strpos($line, ': ') === false) {
	list($head->prot, $head->stat, $head->smsg) = explode(' ', $line, 3);
	$this->statlines[] = $line;
      } else {
	list($k, $v) = explode(': ', $line, 2);
	$head->$k = $v;
      }
    }
    return $head;
  }

  public function status() { return $this->stats[count($this->stats)-1]; }
}