<?php header("Content-Type: text/html; charset= UTF-8");?>
<?php if($doctype == "html5"):?>
<!DOCTYPE html>
<?php elseif($doctype == "xhtml"):?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<?php elseif($doctype == "xhtml strict"):?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<?php elseif($doctype == "html4 strict"):?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd"> 
<?php else: $doctype='html4';?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<?php endif;

if(!defined('CRLF')) define('CRLF', PHP_EOL);

if('xhtml' == substr($doctype, 0, 5))
  echo '<html xmlns="http://www.w3.org/1999/xhtml"><head>' . CRLF;
else {
  echo '<html><head>' . CRLF;
}
echo "  <title>$title</title>" . CRLF;

$eoe = ('html4' == substr($doctype, 0, 5)) ? '>' : '/>'; // end-of-entity
echo '  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"'.$eoe . CRLF;
if(isset($meta_arr) && is_array($meta_arr)) 
  foreach($meta_arr as $k => $v) printf('  <meta name="%s" content="%s"'.$eoe . CRLF, $k, $v);

if(!defined('NoProLib')) 
  foreach(array('nopro_lib', 'noprolib') as $sym) {
    if(file_exists($sym)) {
      define('NoProLib', $sym.'/');
      break;
    }
  }
if(!defined('NoProLib')) 
  define('NoProLib', '');	// null-string

if(!isset($css_arr)) $css_arr[] = NoProLib."css/nopro.css";     // array of css to load
if(!isset($js_arr)) require_once('nop_defaultjs.php');               // set default array of js to load
if(!isset($js_sync)) $js_sync[] = NoProLib."js/jquery.js";      // array of js to load not async

if(is_array($css_arr)) {
  if('html4' == substr($doctype, 0, 5))
    echo '  <META http-equiv="Content-Style-Type" content="text/css"'.$eoe . CRLF;
  foreach($css_arr as $css) printf('  <link href="%s" rel="stylesheet" type="text/css"'.$eoe . CRLF, $css);
}
if(is_array($js_arr))
  foreach($js_arr as $js) 
    if($doctype == "html5" && !in_array($js, $js_sync) && !strstr($js, "liblock.php"))
      printf('  <script type="text/javascript" src="%s" async></script>' .CRLF, $js);
    else
      printf('  <script type="text/javascript" src="%s"></script>' .CRLF, $js);
if(!$nobody):

?>
  
  <!-- mark south-east corner of window -->
  <style type="text/css">#SE_dot { display: block; width: 1px; height: 1px; position: fixed; right: 0px; bottom: 0px; }</style>
  
</head><body<?php if(isset($bodyattr)) echo " $bodyattr";?>>
  
  <noscript><div class="info">Javascript is disabled</div></noscript>
  <div id="SE_dot"></div>
  
<?php endif;?>